#pragma once

#include <Color4.hpp>

#define COLOR static const Color4

namespace Colors {
    COLOR Transparent{0,0,0,0};
    namespace Primary {
        COLOR Red{255, 0, 0};
        COLOR Green{0, 255, 0};
        COLOR Blue{0, 0, 255};
        COLOR White{255, 255, 255};
        COLOR Black{0, 0, 0};
        COLOR Gray{128, 128, 128};
        COLOR DarkGray{192, 192, 192};
        COLOR LightGray{64, 64, 64};
        COLOR Yellow{255, 255, 0};
    }
    using namespace Primary;
    namespace Reds {
        COLOR Fuchsia {255, 0, 255};
        COLOR LightSalmon{255, 160, 122};
        COLOR Salmon{250, 128, 114};
        COLOR DarkSalmon{233, 150, 122};
        COLOR LightCoral{240, 128, 128};
        COLOR IndianRed{205, 92, 92};
        COLOR Crimson{220, 20, 60};
        COLOR Firebrick{178, 34, 34};
        COLOR DarkRed{139, 0, 0};
    }
    namespace Oranges {
        COLOR Coral{255, 127, 80};
        COLOR Tomato{255, 99, 71};
        COLOR OrangeRed{255, 69, 0};
        COLOR Gold{255, 215, 0};
        COLOR Orange{255, 165, 0};
        COLOR DarkOrange{255, 140, 0};
    }
    namespace Yellows {
        COLOR LightYellow{255, 255, 224};
        COLOR LemonChiffon{255, 250, 205};
        COLOR LightGoldenrodYellow{250, 250, 210};
        COLOR PapayaWhip{255, 239, 213};
        COLOR Moccasin{255, 228, 181};
        COLOR PeachPuff{255, 218, 185};
        COLOR PaleGoldenrod{238, 232, 170};
        COLOR Khaki{240, 230, 140};
        COLOR DarkKhaki{189, 183, 107};
    }
    namespace Greens {
        COLOR LawnGreen{124, 252, 0};
        COLOR Chartreuse{127, 255, 0};
        COLOR LimeGreen{50, 205, 50};
        COLOR ForestGreen{34, 139, 34};
        COLOR DarkGreen{0, 100, 0};
        COLOR GreenYellow{173, 255, 47};
        COLOR YellowGreen{154, 205, 50};
        COLOR SpringGreen{0, 255, 127};
        COLOR MediumSpringGreen{0, 250, 154};
        COLOR LightGreen{144, 238, 144};
        COLOR PaleGreen{152, 251, 152};
        COLOR DarkSeaGreen{143, 188, 143};
        COLOR MediumSeaGreen{60, 179, 113};
        COLOR SeaGreen{46, 139, 87};
        COLOR DarkOliveGreen{85, 107, 47};
        COLOR OliveDrab{107, 142, 35};
        COLOR Lime{0, 255, 0};
        COLOR Olive{128, 128, 0};
    }
    namespace Cyans {
        COLOR LightCyan{224, 255, 255};
        COLOR Cyan{0, 255, 255};
        COLOR Aqua{0, 255, 255};
        COLOR Aquamarine{127, 255, 212};
        COLOR MediumAquamarine{102, 205, 170};
        COLOR PaleTurquoise{175, 238, 238};
        COLOR Turquoise{64, 224, 208};
        COLOR MediumTurquoise{72, 209, 204};
        COLOR DarkTurquoise{0, 206, 209};
        COLOR LightSeaGreen{32, 178, 170};
        COLOR CadetBlue{95, 158, 160};
        COLOR DarkCyan{0, 139, 139};
        COLOR Teal{0, 128, 128};
    }
    namespace Blues {
        COLOR PowderBlue{176, 224, 230};
        COLOR LightBlue{173, 216, 230};
        COLOR LightSkyBlue{135, 206, 250};
        COLOR SkyBlue{135, 206, 235};
        COLOR DeepSkyBlue{0, 191, 255};
        COLOR LightSteelBlue{176, 196, 222};
        COLOR DodgerBlue{30, 144, 255};
        COLOR CornflowerBlue{100, 149, 237};
        COLOR SteelBlue{70, 130, 180};
        COLOR RoyalBlue{65, 105, 225};
        COLOR MediumBlue{0, 0, 205};
        COLOR DarkBlue{0, 0, 139};
        COLOR Navy{0, 0, 128};
        COLOR MidnightBlue{25, 25, 112};
        COLOR MediumSlateBlue{123, 104, 238};
        COLOR SlateBlue{106, 90, 205};
        COLOR DarkSlateBlue{72, 61, 139};
    }


    namespace Purples {
        COLOR Lavender{230, 230, 250};
        COLOR Thistle{216, 191, 216};
        COLOR Plum{221, 160, 221};
        COLOR Violet{238, 160, 221};
        COLOR Orchid{218, 112, 214};
        COLOR Fuchsia{255, 0, 255};
        COLOR Magenta{255, 0, 255};
        COLOR MediumOrchid{186, 85, 211};
        COLOR MediumPurple{147, 112, 219};
        COLOR BlueViolet{138, 43, 226};
        COLOR DarkViolet{148, 0, 211};
        COLOR DarkOrchid{153, 50, 204};
        COLOR DarkMagenta{139, 0, 128};
        COLOR Purple{128, 0, 128};
        COLOR Indigo{75, 0, 130};
    }
    namespace Pinks {
        COLOR Pink{255, 129, 203};
        COLOR LightPink{255, 182, 193};
        COLOR HotPink{255, 105, 180};
        COLOR DeepPink{255, 20, 147};
        COLOR PaleVioletRed{219, 112, 147};
        COLOR MediumVioletRed{199, 21, 133};
    }
    namespace Whites {
        COLOR Snow{255, 250, 250};
        COLOR Honeydew{240, 255, 240};
        COLOR MintCream{245, 255, 250};
        COLOR Azure{240, 255, 255};
        COLOR AliceBlue{240, 248, 255};
        COLOR GhostWhite{248, 248, 255};
        COLOR WhiteSmoke{245, 245, 245};
        COLOR SeaShell{255, 245, 238};
        COLOR Beige{245, 245, 220};
        COLOR OldLace{253, 245, 230};
        COLOR FloralWhite{255, 250, 240};
        COLOR Ivory{255, 255, 240};
        COLOR AntiqueWhite{250, 240, 215};
        COLOR Linen{250, 240, 230};
        COLOR LavenderBlush{255, 240, 245};
        COLOR MistyRose{255, 228, 255};
    }
    namespace Grays {
        COLOR Gainsboro{220, 220, 220};
        COLOR LightGray{211, 211, 211};
        COLOR Silver{192, 192, 192};
        COLOR DimGray{105, 105, 105};
        COLOR LightSlateGray{119, 136, 153};
        COLOR SlateGray{112, 128, 144};
        COLOR DarkSlateGray{47, 79, 79};
    }
    namespace Browns {
        COLOR CornSilk{255, 248, 220};
        COLOR BlanchedAlmond{255, 235, 205};
        COLOR Bisque{255, 228, 196};
        COLOR NavajoWhite{255, 222, 173};
        COLOR Wheat{254, 222, 179};
        COLOR BurlyWood{222, 184, 135};
        COLOR Tan{210, 180, 140};
        COLOR RosyBrown{188, 143, 143};
        COLOR SandyBrown{244, 164, 96};
        COLOR GoldenRod{218, 165, 32};
        COLOR Peru{205, 133, 63};
        COLOR Chocolate{210, 105, 30};
        COLOR SaddleBrown{139, 69, 19};
        COLOR Sienna{160, 82, 45};
        COLOR Brown{164, 42, 42};
        COLOR Maroon{128, 0, 0};
    }
}